package com.rc.httpcore.apk

import com.rc.httpcore.bean.ChemicalTimeoutListBean
import com.rc.httpcore.bean.ChemicalWarnInfoBean

data class ProcessedBean(
    val adminInfoList: List<AdminInfo>,
    val buildName: String,
    val chemicalExpireList: List<ChemicalExpire>, //化学品信息显示
    val chemicalOverdueStockList: List<ChemicalWarnInfoBean>?, //超期未入库
    val chemicalTimeoutList: List<ChemicalTimeoutListBean>?, //超期未入库
    val chemicalWarnType: Int,  //1化学品违规带离。2超时未归还。3化学品过期。4化学品即将过期 5 超期未入库 6业务超时
    val deptName: String,
    val floorName: String,
    val handleNotes: String?,
    val handlePerson: String?,
    val handlePersonPhone: Any,
    val handleTime: String?,
    val handleType: Int,
    val isHandlePeople: Boolean,
    val noticeId: String,
    val noticeStatus: Int,
    val roomNum: String,
    val safeInfoList: List<SafeInfo>,
    val safeInfoStr: Any,
    val subName: String,
    val warnContent: String,
    val warnTime: String,
    val belongName: String?,
    val chemicalName: String?,
    val rfidCode: String?,
    val position: String?,
    val collectUserName: String?,
    val surplus: String?,
    val normsNum: String?,
    val collectTime: String?,
    val collectTimeAging: Int,  //小时 需要自己添加
    val warnType: Int,
    val alarmType: String?,
    val operationPerson: String?,
    val snapImg: List<String>?,
    val warningNoticeLogVoList: List<WarningNoticeLogVo>  //通知记录
)