package com.rc.httpcore.bean

import java.math.BigDecimal

//新增-点击确定 需要的参数
class ChemicalABean(
    val belongId: String? = null,   //归属人id
    val belongName: String? = null, //归属人名称
    val casNum: String? = null,
    val chemicalCategory: String? = null,
    val chemicalDensity: Double, // 密度
    val chemicalLevel: Int,   //管控 1     非管控  2
    val chemicalName: String? = null,
    val chemicalNumber: Int, //数量
    val chemicalPurity: String? = null,
    val factory: String? = null,
    val isNew: Boolean,
    val packNum: BigDecimal = BigDecimal("0"),
    val packUnit: String? = null, //包装单位
    val specNum: BigDecimal,  //规格
    val specUnit: String? = null, //规格单位
    var chemicalId: String? = null,
    var belongType: Int = 2,  //1课题组 2人员
    var qrCodePrint: Boolean = true,  //是否打印二维码
    var status: Int? = 2,   //默认非双人认证
)