package com.rc.httpcore.bean

import java.math.BigDecimal

//领用时需要传得参数
data class ChemistryBean(
    val id: String,
    val stockId: String, //库存ID
    val weigh: BigDecimal? = null,   //称重重量  or 零用量
    var outOneUser: String? = null,  //领用第一验证人id
    var outOneUserName: String? = null,  //领用第一验证人姓名
    var outTwoUser: String? = null,  //领用第二验证人id
    var outTwoUserName: String? = null,  //领用第二验证人
    var outType: Int = 1,  //领用方式（1是称重，2是录入)
    var allBottle: Boolean = false,  //是否整瓶领用
    //=====================临时参数 需要显示====================== 领用时可以不传
    var chemicalName: String,
    var code: String,//rfid  or tagCode
    var spec: String,//规格   specNum specUnit/packUnit
    var duration: String,//领用时效
    val stockDetailsId: String, //后端需要得id
    val surplus: BigDecimal,//当前剩余量
    val packNum: BigDecimal,//包装值
    val chemicalDensity: BigDecimal,//密度
    val specUnit: String?,
)
