package com.rc.httpcore.bean

import java.math.BigDecimal

data class StockModel(
    val belongId: String? = null,
    val belongName: String? = null,
    val belongType: Int,
    val buildId: String? = null,
    val buildName: String? = null,
    var cabinetId: String? = null,
    var cabinetName: String? = null,
    val casNum: String? = null,
    val chemicalCategory: Int,
    val chemicalId: String? = null,
    val chemicalLevel: Int,
    val chemicalName: String? = null,
    val chemicalNumber: String? = null,
    val chemicalPurity: String? = null,
    val deptId: String? = null,
    val deptName: String? = null,
    var doorId: String? = null,
    var doorName: String? = null,
    val factory: String? = null,
    val floorId: String? = null,
    val floorName: String? = null,
    val isNew: Boolean,
    val joinType: Int,
    val joinVideo: Any,
    var layers: Int,  //一共几层
    var layersTow: Int,//当前选择得层数
//    val mLayers: Int,  //每一条 总共几层
    val packNum: BigDecimal,   //数量
    val packUnit: String,   //包装单位
    val specNum: Double,
    val specUnit: String, //规格单位
    val stockDetailsModelList: List<StockDetailsModel>?, //每一瓶-的信息
    val stockType: Int,
    val subId: String,
    val subName: String,
    val subRoom: String?,
    var waitId: String? = null,  //只有待入库  使用当前id
    val weigh: Double,   //称重 重量
    val netContent: Double, //  netContent = modelA.chemicalDensity * modelA.specNum  //密度
    val expireTime: String?,
    var oneUserId: String? = null,
    var oneUserName: String? = null,
    var twoUserId: String? = null,
    var twoUserName: String? = null,
)