package xn.hxp.ui.plan.room.dao;

import androidx.room.Dao;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;

import xn.hxp.ui.plan.room.bean.locker.HxpLabDirector;
import xn.hxp.ui.plan.room.bean.locker.HxpLabSafe;

import java.util.List;

@Dao
public interface HxpLabSafeDAO {

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void insertAll(List<HxpLabSafe> users);

    @Query("SELECT * FROM hxplabsafe")
    List<HxpLabSafe> getAll();

    @Query("DELETE FROM hxplabsafe")
    void deleteAll();
}
