package xn.hxp.utils

class Example {
    private val lock = Any() // 创建一个对象作为同步锁

    fun synchronizedMethod() {
        synchronized(lock) {
            // 在这个代码块中的内容在同一时间只能由一个线程访问
            // 添加需要同步的代码逻辑
            println("开始执行同步方法")
            // 例如，假设这里有一些需要同步的代码逻辑
            Thread.sleep(1000) // 模拟一些耗时操作
            println("同步方法执行完毕")
        }
    }
}